<template>
  <aside class="gpa-garden-right-panel">
    <section>
      <rui-menu alternate>
        <rui-menu-item icon="notes"
                       :caption="$t('activerecord.attributes.map.notes')"
                       @click="$emitBus('show-map-notes-form', map)" />

        <rui-menu-item-separator />

        <rui-menu-item icon="calendar-plus"
                       :caption="$t('js.layouts.garden.info.add_map_task')"
                       @click="$emitBus('show-task-form', map)" />

        <rui-menu-item-separator />

        <rui-menu-item icon="observations"
                       :caption="$t('js.layouts.garden.info.add_map_observation')"
                       @click="$emitBus('show-observation-form', map)" />
        <rui-menu-item icon="notebook"
                       :disabled="map.observationsCount === 0"
                       @click="$emitBus('show-observations', map)">
          {{ $t('js.elements.action_buttons.show_observations') }} <small v-if="map.observationsCount > 0">({{ map.observationsCount }})</small>
        </rui-menu-item>
      </rui-menu>
    </section>
    <section>
      <div class="_container -flex">
        <h2 class="-pvd -h6 -flex--grow">{{ $t('js.garden.right_panel.layers.title') }}</h2>
        <div>
          <rui-toolbar>
            <rui-button icon="plus"
                        block
                        variant="creative"
                        :title="$t('js.garden.layers.new_layer')"
                        :disabled="isDrawing"
                        @click="$emitBus('show-layer-form')" />
            <template #right>
              <rui-help-button>
                <rui-help-button-content :caption="$t('js.garden.layers.panel.help.caption')" :content="$t('js.garden.layers.panel.help.content')" :lines="helpLines" />
              </rui-help-button>
            </template>
          </rui-toolbar>
        </div>
      </div>
      <rui-loading v-if="loading" class="gpa-garden-right-panel__loading-notice">{{ $t('generic.loading') }}</rui-loading>

      <div class="gpa-garden-right-panel__list">
        <rui-alert v-if="layers.length === 0" variant="warning">{{ $t('js.garden.layers.no_layers') }}</rui-alert>
        <draggable :model-value="layers"
                   handle="[data-drag-handler]"
                   :disabled="loading"
                   item-key="id"
                   @end="updatePosition">
          <template #item="{element}">
            <rui-list-item :caption="element.name"
                           :data-layer-id="element.id"
                           :active="activeLayer && activeLayer.id === element.id"
                           class="-clickable"
                           @choose="$emit('activate', element)">
              <template #left>
                <rui-button icon="reorder"
                            data-drag-handler="data-drag-handler"
                            :disabled="isDrawing"
                            :title="$t('js.layers.move')"
                            text />
              </template>
              <template #right>
                <rui-button :icon="visibleLayers && visibleLayers.indexOf(element.id) === -1 ? 'eye-slash' : 'eye'"
                            :title="$t('js.layers.toggle')"
                            @click="$emit('toggle', element.id)" />
                <rui-button icon="pencil" :title="$t('generic.edit')" @click="$emitBus('show-layer-form', element)" />
                <rui-button icon="trash"
                            text
                            variant="destructive"
                            :title="$t('generic.destroy')"
                            @click="destroyLayer(element)" />
              </template>
            </rui-list-item>
          </template>
        </draggable>
        <rui-list-item :caption="$t('js.layers.background_layer')">
          <template #left>
            <rui-button icon="blank" text no-action />
          </template>
          <template #right>
            <rui-button icon="blank" text no-action />
            <rui-button :icon="map.hideBackground ? 'eye-slash' : 'eye'" @click="toggleBackgroundVisibility" />
            <rui-button icon="blank" text no-action />
          </template>
        </rui-list-item>
      </div>
    </section>
  </aside>
</template>

<script>
import RuiAlert from '@experiments-labs/rise_ui/src/components/Alert/Alert.vue'
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiHelpButton from '@experiments-labs/rise_ui/src/components/HelpButton/HelpButton.vue'
import RuiHelpButtonContent from '@experiments-labs/rise_ui/src/components/HelpButton/HelpButtonContent.vue'
import RuiListItem from '@experiments-labs/rise_ui/src/components/ListItem/ListItem.vue'
import RuiLoading from '@experiments-labs/rise_ui/src/components/Loading/Loading.vue'
import RuiMenu from '@experiments-labs/rise_ui/src/components/Menu/Menu.vue'
import RuiMenuItem from '@experiments-labs/rise_ui/src/components/Menu/MenuItem.vue'
import RuiMenuItemSeparator from '@experiments-labs/rise_ui/src/components/Menu/MenuItemSeparator.vue'
import RuiToolbar from '@experiments-labs/rise_ui/src/components/Toolbar/Toolbar.vue'

import { markRaw } from 'vue'
import Draggable from 'vuedraggable'
import Layer from '../../../../../classes/models/Layer'
import Toaster from '../../../../../tools/Toaster'
import GpaLayerDestroyWarning from '../../Layers/_DestroyWarning.vue'

const rawDestroyWarning = markRaw(GpaLayerDestroyWarning)

export default {
  name: 'GpaRightPanel',
  emits: [
    'activate',
    'toggle',
  ],
  components: {
    RuiHelpButton,
    RuiHelpButtonContent,
    RuiListItem,
    RuiAlert,
    RuiLoading,
    RuiButton,
    RuiToolbar,
    RuiMenuItemSeparator,
    RuiMenuItem,
    RuiMenu,
    Draggable,
  },
  props: {
    visibleLayers: { required: false, type: Array, default: null },
    activeLayer: { required: false, type: Layer, default: null },
    isDrawing: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      loading: false,
      helpLines: [
        { icon: 'plus', text: this.$t('js.garden.layers.panel.help.add') },
        { icon: 'reorder', text: this.$t('js.garden.layers.panel.help.reorder') },
        { icon: 'pencil', text: this.$t('js.garden.layers.panel.help.edit') },
        { icon: 'eye', text: this.$t('js.garden.layers.panel.help.toggle') },
        { icon: 'trash', text: this.$t('js.garden.layers.panel.help.destroy'), variant: 'danger' },
      ],
    }
  },
  computed: {
    currentMap () { return this.$store.getters.map(this.currentMapId) },
    layers () { return this.$store.getters.layers },
    map () { return this.$store.getters.map(parseInt(this.$route.params.mapId, 10)) },
  },
  methods: {
    updatePosition (event) {
      if (event.newIndex === event.oldIndex) return

      this.loading = true
      // List is reversed
      const position = this.layers.length - (event.newIndex)
      const payload = { id: parseInt(event.item.dataset.layerId, 10), position }
      this.$store.dispatch('updateLayer', payload)
        .then(() => this.$store.dispatch('loadLayers', this.$route.params.mapId)
          .then(() => {
            this.layers.forEach((l) => { l.mapLayer.setZIndex(l.position) })
          }))
        .then(() => { this.loading = false })
    },
    toggleBackgroundVisibility () {
      this.$store.dispatch('updateMap', { id: this.map.id, hide_background: !this.map.hideBackground })
    },
    destroyLayer (layer) {
      const patches = layer.patches.length
      const paths = layer.paths.length
      if (patches + paths > 0) {
        let message

        if (patches > 0 && paths > 0) message = this.$t('js.layers.patches_and_paths_remaining', { patches_count: patches, paths_count: paths })
        else if (patches > 0) message = this.$t('js.layers.patches_remaining', { count: patches })
        else message = this.$t('js.layers.paths_remaining', { count: paths })

        this.$emitBus('display-information', {
          caption: this.$t('js.generic.impossible_action'),
          acceptable: false,
          message,
        })
        return
      }
      this.$emitBus('ask-confirmation', {
        caption: this.$t('js.layer.destroy_warning_title'),
        component: rawDestroyWarning,
        callback: () => {
          this.$store.dispatch('destroyLayer', layer.id)
            .then(() => {
              this.$emitBus('layer-removed', layer)
              Toaster.success(this.$t('js.layers.successfully_destroyed'))
            })
            .catch(() => { Toaster.error(this.$t('js.layers.failed_to_destroy')) })
        },
      })
    },
  },
  created () {
    // Deactivate layers when specified
    this.$nextTick(() => {
      this.layers.forEach((l) => { if (!l.visibleByDefault) this.$emit('toggle', l.id) })
    })
  },
}
</script>

<style lang="scss" src="./_RightPanel.scss" />
